﻿#region License

// ------------------------------------------------------------------------------------------- //
// The MIT License (MIT)                                                                       //
// Copyright (c) 2012 adaptive modeling interface                                              //
//                                                                                             //
// Permission is hereby granted, free of charge, to any person obtaining a copy of this        //
// software and associated documentation files (the "Software"), to deal in the Software       //
// without restriction, including without limitation the rights to use, copy, modify, merge,   //
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons  //
// to whom the Software is furnished to do so, subject to the following conditions:            //
//                                                                                             //
// The above copyright notice and this permission notice shall be included in all copies or    //
// substantial portions of the Software.                                                       //
//                                                                                             //
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,         //
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR    //
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE   //
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR        //
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER      //
// DEALINGS IN THE SOFTWARE.                                                                   //
// ------------------------------------------------------------------------------------------- //

#endregion

using System;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using Ami.Objects.Relations;

namespace Ami.Objects.Core.Templates
{
#line 1 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
    [GeneratedCode("Microsoft.VisualStudio.TextTemplating", "10.0.0.0")]
    public partial class BaseObjectTemplate : BaseObjectTemplateBase
    {
        public virtual string TransformText()
        {
            return GenerationEnvironment.ToString();
        }

#line 5 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
        protected void CreateRelations()
        {
            var relations = Type.Relations;
            var domainRelation = Type.DomainRelation;
            var ownerRelation = Type.OwnerRelation;
            var domainRelationName = domainRelation.Name;
            var ownerRelationName = ownerRelation.Name;
            var nbRelations = relations.Length;
            var domainAsOwner = domainRelation == ownerRelation;
            if (domainAsOwner) ++nbRelations;


#line default
#line hidden

#line 15 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("\t\tprotected override ");


#line default
#line hidden

#line 16 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(ToStringHelper.ToStringWithCulture(QualifiedName<IRelation[]>()));


#line default
#line hidden

#line 16 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(" CreateRelations()\r\n\t\t{\r\n\t");


#line default
#line hidden

#line 18 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            foreach (var relation in Type.Relations.Where(r => r != Type.DomainRelation))
            {
#line default
#line hidden

#line 19 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("\t\t\t");


#line default
#line hidden

#line 19 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(relation.Name));


#line default
#line hidden

#line 19 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("Relation = ");


#line default
#line hidden

#line 19 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(relation.Kind.CreateRelation(relation, false)));


#line default
#line hidden

#line 19 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(";\r\n\t");


#line default
#line hidden

#line 20 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            }

#line default
#line hidden

#line 21 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("\t");


#line default
#line hidden

#line 22 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            if (domainAsOwner)
            {
#line default
#line hidden

#line 23 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("\t\t\tOwnerRelation = ");


#line default
#line hidden

#line 23 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(ownerRelation.Kind.CreateRelation(ownerRelation, false)));


#line default
#line hidden

#line 23 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(";\r\n\t");


#line default
#line hidden

#line 24 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            }

#line default
#line hidden

#line 25 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("\t\t\tvar relations = new ");


#line default
#line hidden

#line 26 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(ToStringHelper.ToStringWithCulture(QualifiedName<IRelation>()));


#line default
#line hidden

#line 26 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("[");


#line default
#line hidden

#line 26 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(ToStringHelper.ToStringWithCulture(nbRelations));


#line default
#line hidden

#line 26 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("];\r\n\t");


#line default
#line hidden

#line 27 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            for (var i = 0; i < nbRelations; ++i)
            {
                string relationName;
                switch (i)
                {
                    case 0:
                        relationName = "Domain";
                        break;
                    case 1:
                        relationName = "Owner";
                        break;
                    default:
                        relationName = relations[domainRelation == ownerRelation ? i - 1 : i].Name;
                        break;
                }


#line default
#line hidden

#line 42 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("\t\t\trelations[");


#line default
#line hidden

#line 43 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(i));


#line default
#line hidden

#line 43 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("] = ");


#line default
#line hidden

#line 43 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(relationName));


#line default
#line hidden

#line 43 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("Relation;\r\n\t");


#line default
#line hidden

#line 44 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            }

#line default
#line hidden

#line 45 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("\t\t\treturn relations;\r\n\t\t}\r\n");


#line default
#line hidden

#line 48 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
        }

#line default
#line hidden

#line 52 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
        protected void DoGetRelation()
        {
#line default
#line hidden

#line 54 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write("\t\tprotected override ");


#line default
#line hidden

#line 55 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(ToStringHelper.ToStringWithCulture(QualifiedName<IRelation>()));


#line default
#line hidden

#line 55 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            Write(" DoGetRelation(string name)\r\n\t\t{\r\n\t\t\treturn null;\r\n\t\t}\r\n");


#line default
#line hidden

#line 59 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
        }

#line default
#line hidden

#line 62 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
        protected void ImplementRelations()
        {
            foreach (var relation in Type.Relations)
            {
#line default
#line hidden

#line 65 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("\t\t");


#line default
#line hidden

#line 66 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write(ToStringHelper.ToStringWithCulture(relation.Kind.Implement(relation)));


#line default
#line hidden

#line 66 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
                Write("\r\n\t");


#line default
#line hidden

#line 67 "C:\Users\strat\doclib\src\code\work\ami2\src\Ami.Objects\Core\Templates\BaseObjectTemplate.tt"
            }
        }

#line default
#line hidden
    }

#line default
#line hidden

    #region Base class

    /// <summary>
    /// Base class for this transformation
    /// </summary>
    [GeneratedCode("Microsoft.VisualStudio.TextTemplating", "10.0.0.0")]
    public class BaseObjectTemplateBase
    {
        #region Fields

        private StringBuilder generationEnvironmentField;
        private CompilerErrorCollection errorsField;
        private List<int> indentLengthsField;
        private string currentIndentField = "";
        private bool endsWithNewline;
        private IDictionary<string, object> sessionField;

        #endregion

        #region Properties

        /// <summary>
        /// The string builder that generation-time code is using to assemble generated output
        /// </summary>
        protected StringBuilder GenerationEnvironment
        {
            get
            {
                if ((generationEnvironmentField == null))
                {
                    generationEnvironmentField = new StringBuilder();
                }
                return generationEnvironmentField;
            }
            set { generationEnvironmentField = value; }
        }

        /// <summary>
        /// The error collection for the generation process
        /// </summary>
        public CompilerErrorCollection Errors
        {
            get
            {
                if ((errorsField == null))
                {
                    errorsField = new CompilerErrorCollection();
                }
                return errorsField;
            }
        }

        /// <summary>
        /// A list of the lengths of each indent that was added with PushIndent
        /// </summary>
        private List<int> indentLengths
        {
            get
            {
                if ((indentLengthsField == null))
                {
                    indentLengthsField = new List<int>();
                }
                return indentLengthsField;
            }
        }

        /// <summary>
        /// Gets the current indent we use when adding lines to the output
        /// </summary>
        public string CurrentIndent
        {
            get { return currentIndentField; }
        }

        /// <summary>
        /// Current transformation session
        /// </summary>
        public virtual IDictionary<string, object> Session
        {
            get { return sessionField; }
            set { sessionField = value; }
        }

        #endregion

        #region Transform-time helpers

        /// <summary>
        /// Write text directly into the generated output
        /// </summary>
        public void Write(string textToAppend)
        {
            if (string.IsNullOrEmpty(textToAppend))
            {
                return;
            }
            // If we're starting off, or if the previous text ended with a newline,
            // we have to append the current indent first.
            if (((GenerationEnvironment.Length == 0)
                 || endsWithNewline))
            {
                GenerationEnvironment.Append(currentIndentField);
                endsWithNewline = false;
            }
            // Check if the current text ends with a newline
            if (textToAppend.EndsWith(Environment.NewLine, StringComparison.CurrentCulture))
            {
                endsWithNewline = true;
            }
            // This is an optimization. If the current indent is "", then we don't have to do any
            // of the more complex stuff further down.
            if ((currentIndentField.Length == 0))
            {
                GenerationEnvironment.Append(textToAppend);
                return;
            }
            // Everywhere there is a newline in the text, add an indent after it
            textToAppend = textToAppend.Replace(Environment.NewLine, (Environment.NewLine + currentIndentField));
            // If the text ends with a newline, then we should strip off the indent added at the very end
            // because the appropriate indent will be added when the next time Write() is called
            if (endsWithNewline)
            {
                GenerationEnvironment.Append(textToAppend, 0, (textToAppend.Length - currentIndentField.Length));
            }
            else
            {
                GenerationEnvironment.Append(textToAppend);
            }
        }

        /// <summary>
        /// Write text directly into the generated output
        /// </summary>
        public void WriteLine(string textToAppend)
        {
            Write(textToAppend);
            GenerationEnvironment.AppendLine();
            endsWithNewline = true;
        }

        /// <summary>
        /// Write formatted text directly into the generated output
        /// </summary>
        public void Write(string format, params object[] args)
        {
            Write(string.Format(CultureInfo.CurrentCulture, format, args));
        }

        /// <summary>
        /// Write formatted text directly into the generated output
        /// </summary>
        public void WriteLine(string format, params object[] args)
        {
            WriteLine(string.Format(CultureInfo.CurrentCulture, format, args));
        }

        /// <summary>
        /// Raise an error
        /// </summary>
        public void Error(string message)
        {
            var error = new CompilerError();
            error.ErrorText = message;
            Errors.Add(error);
        }

        /// <summary>
        /// Raise a warning
        /// </summary>
        public void Warning(string message)
        {
            var error = new CompilerError();
            error.ErrorText = message;
            error.IsWarning = true;
            Errors.Add(error);
        }

        /// <summary>
        /// Increase the indent
        /// </summary>
        public void PushIndent(string indent)
        {
            if ((indent == null))
            {
                throw new ArgumentNullException("indent");
            }
            currentIndentField = (currentIndentField + indent);
            indentLengths.Add(indent.Length);
        }

        /// <summary>
        /// Remove the last indent that was added with PushIndent
        /// </summary>
        public string PopIndent()
        {
            var returnValue = "";
            if ((indentLengths.Count > 0))
            {
                var indentLength = indentLengths[(indentLengths.Count - 1)];
                indentLengths.RemoveAt((indentLengths.Count - 1));
                if ((indentLength > 0))
                {
                    returnValue = currentIndentField.Substring((currentIndentField.Length - indentLength));
                    currentIndentField = currentIndentField.Remove((currentIndentField.Length - indentLength));
                }
            }
            return returnValue;
        }

        /// <summary>
        /// Remove any indentation
        /// </summary>
        public void ClearIndent()
        {
            indentLengths.Clear();
            currentIndentField = "";
        }

        #endregion

        #region ToString Helpers

        /// <summary>
        /// Utility class to produce culture-oriented representation of an object as a string.
        /// </summary>
        public class ToStringInstanceHelper
        {
            private IFormatProvider formatProviderField = CultureInfo.InvariantCulture;

            /// <summary>
            /// Gets or sets format provider to be used by ToStringWithCulture method.
            /// </summary>
            public IFormatProvider FormatProvider
            {
                get { return formatProviderField; }
                set
                {
                    if ((value != null))
                    {
                        formatProviderField = value;
                    }
                }
            }

            /// <summary>
            /// This is called from the compile/run appdomain to convert objects within an expression block to a string
            /// </summary>
            public string ToStringWithCulture(object objectToConvert)
            {
                if ((objectToConvert == null))
                {
                    throw new ArgumentNullException("objectToConvert");
                }
                var t = objectToConvert.GetType();
                var method = t.GetMethod("ToString", new Type[]
                                                         {
                                                             typeof (IFormatProvider)
                                                         });
                if ((method == null))
                {
                    return objectToConvert.ToString();
                }
                else
                {
                    return ((string) (method.Invoke(objectToConvert, new object[]
                                                                         {
                                                                             formatProviderField
                                                                         })));
                }
            }
        }

        private ToStringInstanceHelper toStringHelperField = new ToStringInstanceHelper();

        public ToStringInstanceHelper ToStringHelper
        {
            get { return toStringHelperField; }
        }

        #endregion
    }

    #endregion
}