#region License

// ------------------------------------------------------------------------------------------- //
// The MIT License (MIT)                                                                       //
// Copyright (c) 2012 adaptive modeling interface                                              //
//                                                                                             //
// Permission is hereby granted, free of charge, to any person obtaining a copy of this        //
// software and associated documentation files (the "Software"), to deal in the Software       //
// without restriction, including without limitation the rights to use, copy, modify, merge,   //
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons  //
// to whom the Software is furnished to do so, subject to the following conditions:            //
//                                                                                             //
// The above copyright notice and this permission notice shall be included in all copies or    //
// substantial portions of the Software.                                                       //
//                                                                                             //
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,         //
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR    //
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE   //
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR        //
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER      //
// DEALINGS IN THE SOFTWARE.                                                                   //
// ------------------------------------------------------------------------------------------- //

#endregion

namespace Ami.Objects.Relations
{
    /// <summary>
    /// A <see cref="IRelation"/> as property.
    /// </summary>
    public interface IProperty : IOwningRelation
    {
    }

    /// <summary>
    /// A typed <see cref="IProperty"/>.
    /// </summary>
    /// <typeparam name="T">Property type.</typeparam>
    public interface IProperty<T> : IProperty where T : IObject
    {
    }

    /// <summary>
    /// Typed <see cref="IProperty"/>.
    /// </summary>
    /// <typeparam name="T">Property type.</typeparam>
    /// <typeparam name="TOnwer">Owner type.</typeparam>
    public interface IProperty<T, out TOnwer> : IProperty<T>, IRelation<TOnwer> where T : IObject where TOnwer : IObject
    {
    }
}